/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/joystick_drivers/wiimote/msg/IrSourceInfo.msg.  Do not edit! */
#ifndef WIIMOTE_IRSOURCEINFO_H
#define WIIMOTE_IRSOURCEINFO_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace wiimote
{

//! \htmlinclude IrSourceInfo.msg.html

class IrSourceInfo : public ros::Message
{
public:
  typedef boost::shared_ptr<IrSourceInfo> Ptr;
  typedef boost::shared_ptr<IrSourceInfo const> ConstPtr;

  typedef double _x_type;
  typedef double _y_type;
  typedef int64_t _ir_size_type;

  double x;
  double y;
  int64_t ir_size;

  IrSourceInfo() : ros::Message(),
    x(0),
    y(0),
    ir_size(0)
  {
  }
  IrSourceInfo(const IrSourceInfo &copy) : ros::Message(),
    x(copy.x),
    y(copy.y),
    ir_size(copy.ir_size)
  {
    (void)copy;
  }
  IrSourceInfo &operator =(const IrSourceInfo &copy)
  {
    if (this == &copy)
      return *this;
    x = copy.x;
    y = copy.y;
    ir_size = copy.ir_size;
    return *this;
  }
  virtual ~IrSourceInfo() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("wiimote/IrSourceInfo"); }
  inline static std::string __s_getMD5Sum() { return std::string("95274ca88b9f008b99984b9a61d2772e"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Sensor data pertaining to the Wiimote infrared camera.\n"
    "# This message contains data for one of the four infrared \n"
    "# light sources that the camera detects.\n"
    "#\n"
    "# Each light is specified with a 2D position and \n"
    "# a 'source magnitude' (ir_size). If the x dimension\n"
    "# is set to INVALID_FLOAT, then no light was detected for \n"
    "# the respective light. The Wiimote handles up to\n"
    "# four light sources, and the wiimote_node.py software\n"
    "# is written to that limit as well.\n"
    "#\n"
    "# I am unsure what the 'ir_size' values represent. \n"
    "# They are described as 'source magnitude' in some places. I\n"
    "# *assume* this is signal amplitude, but it's unclear. \n"
    "# Note that current lowest level cwiid driver does not \n"
    "# seem to pass the ir_size value to the cwiid Wiimote.c. \n"
    "# For now this size will therefore be set INVALID\n"
    "\n"
    "float64 x \n"
    "float64 y \n"
    "int64 ir_size\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 8; // x
    __l += 8; // y
    __l += 8; // ir_size
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, x);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, y);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, ir_size);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, x);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, y);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, ir_size);
    return read_ptr;
  }
};

typedef boost::shared_ptr<IrSourceInfo> IrSourceInfoPtr;
typedef boost::shared_ptr<IrSourceInfo const> IrSourceInfoConstPtr;


}

#endif
