/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/joystick_drivers/wiimote/msg/LEDControl.msg.  Do not edit! */
#ifndef WIIMOTE_LEDCONTROL_H
#define WIIMOTE_LEDCONTROL_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "wiimote/TimedSwitch.h"

namespace wiimote
{

//! \htmlinclude LEDControl.msg.html

class LEDControl : public ros::Message
{
public:
  typedef boost::shared_ptr<LEDControl> Ptr;
  typedef boost::shared_ptr<LEDControl const> ConstPtr;

  typedef std::vector<wiimote::TimedSwitch> _timed_switch_array_type;

  std::vector<wiimote::TimedSwitch> timed_switch_array;

  LEDControl() : ros::Message()
  {
  }
  LEDControl(const LEDControl &copy) : ros::Message()
  {
    (void)copy;
    timed_switch_array = copy.timed_switch_array;
  }
  LEDControl &operator =(const LEDControl &copy)
  {
    if (this == &copy)
      return *this;
    timed_switch_array.clear();
    timed_switch_array = copy.timed_switch_array;
    return *this;
  }
  virtual ~LEDControl() 
  {
    timed_switch_array.clear();
  }
  inline static std::string __s_getDataType() { return std::string("wiimote/LEDControl"); }
  inline static std::string __s_getMD5Sum() { return std::string("d0477eee2c164b8a9582a596f92c6f08"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Message to request Wiimote LED operations. The Wiimote has four\n"
    "# LEDs. This message enables its user to turn each individual LED\n"
    "# on or off, and to define a blink pattern for each LEDs.\n"
    "#        See TimedSwitch.msg for details.\n"
    "\n"
    "TimedSwitch[] timed_switch_array  \n"
    "\n"
    "================================================================================\n"
    "MSG: wiimote/TimedSwitch\n"
    "# TimedSwitch allows sender to:\n"
    "#    o turn a switch on,\n"
    "#    o turn a switch off, and\n"
    "#    o repeat an on/off pattern forever or for a\n"
    "#          given number of times.\n"
    "# Fields (refer to definitions of constants in the definition body):\n"
    "#     o switch_mode:\n"
    "#         ON: turn on  (num_cycles and pulse_pattern fields are ignored)\n"
    "#        OFF: turn off (num_cycles and pulse_pattern fields are ignored)\n"
    "#  NO_CHANGE: leave LED in its current state\n"
    "#     REPEAT: repeat an on/off pattern for as long\n"
    "#             as is indicated in the num_cycles field. The\n"
    "#             pattern is defined in the pulse_pattern field.\n"
    "#\n"
    "#     o num_cycles:\n"
    "#          n>=0: run the pattern that is defined in pulse_pattern\n"
    "#                n times.\n"
    "#          n==FOREVER: run the pattern that is defined in pulse_pattern\n"
    "#                       until a new TimedSwitch message is sent.              \n"
    "#\n"
    "#     o pulse_pattern:\n"
    "#          A series of time durations in fractions of a second. The\n"
    "#          first number is the duration for having the switch on.\n"
    "#          The second number is the duration for which the switch\n"
    "#          is off. The third is an 'on' period again, etc.\n"
    "#          A pattern is terminated with the end of the array.\n"
    "#           \n"
    "#          Example: [1,1] specifies an on-off sequence of 1 second.               \n"
    "\n"
    "int8 ON        =  1\n"
    "int8 OFF       =  0\n"
    "int8 NO_CHANGE = -2\n"
    "int8 REPEAT    = -1\n"
    "int8 FOREVER   = -1\n"
    "\n"
    "int8 switch_mode\n"
    "int32 num_cycles\n"
    "float32[] pulse_pattern\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_timed_switch_array_size(uint32_t __ros_new_size)
  {
    this->timed_switch_array.resize(__ros_new_size);
  }
  inline uint32_t get_timed_switch_array_size() const { return timed_switch_array.size(); }
  uint32_t calc_timed_switch_array_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t timed_switch_array_size = timed_switch_array.size();
    for (size_t i = 0; i < timed_switch_array_size; i++)
      l += timed_switch_array[i].serializationLength();
    return l;
  }
  inline void get_timed_switch_array_vec (std::vector<wiimote::TimedSwitch> &__ros_vec) const
  {
    __ros_vec = this->timed_switch_array;
  }
  inline void set_timed_switch_array_vec(const std::vector<wiimote::TimedSwitch> &__ros_vec)
  {
    this->timed_switch_array = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_timed_switch_array_array_serialization_len(); // timed_switch_array
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __timed_switch_array_size = timed_switch_array.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __timed_switch_array_size);
    for (size_t i = 0; i < __timed_switch_array_size; i++)
      write_ptr = timed_switch_array[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __timed_switch_array_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __timed_switch_array_size);
    set_timed_switch_array_size(__timed_switch_array_size);
    for (size_t i = 0; i < __timed_switch_array_size; i++)
      read_ptr = timed_switch_array[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<LEDControl> LEDControlPtr;
typedef boost::shared_ptr<LEDControl const> LEDControlConstPtr;


}

#endif
