/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/joystick_drivers/wiimote/msg/RumbleControl.msg.  Do not edit! */
#ifndef WIIMOTE_RUMBLECONTROL_H
#define WIIMOTE_RUMBLECONTROL_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "wiimote/TimedSwitch.h"

namespace wiimote
{

//! \htmlinclude RumbleControl.msg.html

class RumbleControl : public ros::Message
{
public:
  typedef boost::shared_ptr<RumbleControl> Ptr;
  typedef boost::shared_ptr<RumbleControl const> ConstPtr;

  typedef wiimote::TimedSwitch _rumble_type;

  wiimote::TimedSwitch rumble;

  RumbleControl() : ros::Message()
  {
  }
  RumbleControl(const RumbleControl &copy) : ros::Message(),
    rumble(copy.rumble)
  {
    (void)copy;
  }
  RumbleControl &operator =(const RumbleControl &copy)
  {
    if (this == &copy)
      return *this;
    rumble = copy.rumble;
    return *this;
  }
  virtual ~RumbleControl() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("wiimote/RumbleControl"); }
  inline static std::string __s_getMD5Sum() { return std::string("264ec2f3013a512070cd67c42486214e"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Message to control the Wiimote rumble (vibrator).\n"
    "# We simply use a TimedSwitch. So rumble can\n"
    "# be turned on (switch_mode == 1), off (switch_mode == 0),\n"
    "# or pulsed with a timing pattern (switch_mode == -1).\n"
    "# Number of times the cycle is repeated: num_cycles\n"
    "# (-1: repeat till next RumbleControl message). pulse_pattern\n"
    "# contains the time on/off pattern. (see also TimedSwitch.msg)\n"
    "\n"
    "TimedSwitch rumble\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: wiimote/TimedSwitch\n"
    "# TimedSwitch allows sender to:\n"
    "#    o turn a switch on,\n"
    "#    o turn a switch off, and\n"
    "#    o repeat an on/off pattern forever or for a\n"
    "#          given number of times.\n"
    "# Fields (refer to definitions of constants in the definition body):\n"
    "#     o switch_mode:\n"
    "#         ON: turn on  (num_cycles and pulse_pattern fields are ignored)\n"
    "#        OFF: turn off (num_cycles and pulse_pattern fields are ignored)\n"
    "#  NO_CHANGE: leave LED in its current state\n"
    "#     REPEAT: repeat an on/off pattern for as long\n"
    "#             as is indicated in the num_cycles field. The\n"
    "#             pattern is defined in the pulse_pattern field.\n"
    "#\n"
    "#     o num_cycles:\n"
    "#          n>=0: run the pattern that is defined in pulse_pattern\n"
    "#                n times.\n"
    "#          n==FOREVER: run the pattern that is defined in pulse_pattern\n"
    "#                       until a new TimedSwitch message is sent.              \n"
    "#\n"
    "#     o pulse_pattern:\n"
    "#          A series of time durations in fractions of a second. The\n"
    "#          first number is the duration for having the switch on.\n"
    "#          The second number is the duration for which the switch\n"
    "#          is off. The third is an 'on' period again, etc.\n"
    "#          A pattern is terminated with the end of the array.\n"
    "#           \n"
    "#          Example: [1,1] specifies an on-off sequence of 1 second.               \n"
    "\n"
    "int8 ON        =  1\n"
    "int8 OFF       =  0\n"
    "int8 NO_CHANGE = -2\n"
    "int8 REPEAT    = -1\n"
    "int8 FOREVER   = -1\n"
    "\n"
    "int8 switch_mode\n"
    "int32 num_cycles\n"
    "float32[] pulse_pattern\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += rumble.serializationLength(); // rumble
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = rumble.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = rumble.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<RumbleControl> RumbleControlPtr;
typedef boost::shared_ptr<RumbleControl const> RumbleControlConstPtr;


}

#endif
