/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/joystick_drivers/wiimote/msg/State.msg.  Do not edit! */
#ifndef WIIMOTE_STATE_H
#define WIIMOTE_STATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Vector3.h"
#include "wiimote/IrSourceInfo.h"
#include "roslib/Time.h"

namespace wiimote
{

//! \htmlinclude State.msg.html

class State : public ros::Message
{
public:
  typedef boost::shared_ptr<State> Ptr;
  typedef boost::shared_ptr<State const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef geometry_msgs::Vector3 _angular_velocity_zeroed_type;
  typedef geometry_msgs::Vector3 _angular_velocity_raw_type;
  typedef boost::array<double, 9> _angular_velocity_covariance_type;
  typedef geometry_msgs::Vector3 _linear_acceleration_zeroed_type;
  typedef geometry_msgs::Vector3 _linear_acceleration_raw_type;
  typedef boost::array<double, 9> _linear_acceleration_covariance_type;
  typedef boost::array<uint8_t, 11> _buttons_type;
  typedef boost::array<uint8_t, 4> _LEDs_type;
  typedef uint8_t _rumble_type;
  typedef std::vector<wiimote::IrSourceInfo> _ir_tracking_type;
  typedef float _raw_battery_type;
  typedef float _percent_battery_type;
  typedef roslib::Time _zeroing_time_type;
  typedef uint64_t _errors_type;

  const static int8_t INVALID = -1;
  const float INVALID_FLOAT;
  const static int8_t MSG_BTN_1 = 0;
  const static int8_t MSG_BTN_2 = 1;
  const static int8_t MSG_BTN_A = 2;
  const static int8_t MSG_BTN_B = 3;
  const static int8_t MSG_BTN_PLUS = 4;
  const static int8_t MSG_BTN_MINUS = 5;
  const static int8_t MSG_BTN_LEFT = 6;
  const static int8_t MSG_BTN_RIGHT = 7;
  const static int8_t MSG_BTN_UP = 8;
  const static int8_t MSG_BTN_DOWN = 9;
  const static int8_t MSG_BTN_HOME = 10;
  roslib::Header header;
  geometry_msgs::Vector3 angular_velocity_zeroed;
  geometry_msgs::Vector3 angular_velocity_raw;
  boost::array<double, 9> angular_velocity_covariance;
  geometry_msgs::Vector3 linear_acceleration_zeroed;
  geometry_msgs::Vector3 linear_acceleration_raw;
  boost::array<double, 9> linear_acceleration_covariance;
  boost::array<uint8_t, 11> buttons;
  boost::array<uint8_t, 4> LEDs;
  uint8_t rumble;
  std::vector<wiimote::IrSourceInfo> ir_tracking;
  float raw_battery;
  float percent_battery;
  roslib::Time zeroing_time;
  uint64_t errors;

  State() : ros::Message(),
    INVALID_FLOAT(-1.0),
    rumble(0),
    raw_battery(0),
    percent_battery(0),
    errors(0)
  {
    angular_velocity_covariance.assign(0);
    linear_acceleration_covariance.assign(0);
    buttons.assign(0);
    LEDs.assign(0);
  }
  State(const State &copy) : ros::Message(),
    INVALID_FLOAT(copy.INVALID_FLOAT),
    header(copy.header),
    angular_velocity_zeroed(copy.angular_velocity_zeroed),
    angular_velocity_raw(copy.angular_velocity_raw),
    linear_acceleration_zeroed(copy.linear_acceleration_zeroed),
    linear_acceleration_raw(copy.linear_acceleration_raw),
    rumble(copy.rumble),
    raw_battery(copy.raw_battery),
    percent_battery(copy.percent_battery),
    zeroing_time(copy.zeroing_time),
    errors(copy.errors)
  {
    (void)copy;
    angular_velocity_covariance = copy.angular_velocity_covariance;
    linear_acceleration_covariance = copy.linear_acceleration_covariance;
    buttons = copy.buttons;
    LEDs = copy.LEDs;
    ir_tracking = copy.ir_tracking;
  }
  State &operator =(const State &copy)
  {
    if (this == &copy)
      return *this;
    ir_tracking.clear();
    header = copy.header;
    angular_velocity_zeroed = copy.angular_velocity_zeroed;
    angular_velocity_raw = copy.angular_velocity_raw;
    angular_velocity_covariance = copy.angular_velocity_covariance;
    linear_acceleration_zeroed = copy.linear_acceleration_zeroed;
    linear_acceleration_raw = copy.linear_acceleration_raw;
    linear_acceleration_covariance = copy.linear_acceleration_covariance;
    buttons = copy.buttons;
    LEDs = copy.LEDs;
    rumble = copy.rumble;
    ir_tracking = copy.ir_tracking;
    raw_battery = copy.raw_battery;
    percent_battery = copy.percent_battery;
    zeroing_time = copy.zeroing_time;
    errors = copy.errors;
    return *this;
  }
  virtual ~State() 
  {
    ir_tracking.clear();
  }
  inline static std::string __s_getDataType() { return std::string("wiimote/State"); }
  inline static std::string __s_getMD5Sum() { return std::string("eb6e58dcb35bfb71c9eed6687cfd0377"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#\n"
    "#          Wiimote State message containing one complete Wiimote state\n"
    "\n"
    "# Note: For ease of manipulation this message often uses\n"
    "#       int8[] when a bit vector would work. One might\n"
    "#       wish to use uint8[], but then Python takes\n"
    "#       the respective structure as a string and disallows\n"
    "#       item assignment.\n"
    "\n"
    "int8    INVALID       = -1\n"
    "float32 INVALID_FLOAT = -1.0\n"
    "\n"
    "int8 MSG_BTN_1     = 0\n"
    "int8 MSG_BTN_2     = 1\n"
    "int8 MSG_BTN_A     = 2\n"
    "int8 MSG_BTN_B     = 3\n"
    "int8 MSG_BTN_PLUS  = 4\n"
    "int8 MSG_BTN_MINUS = 5\n"
    "int8 MSG_BTN_LEFT  = 6\n"
    "int8 MSG_BTN_RIGHT = 7\n"
    "int8 MSG_BTN_UP    = 8\n"
    "int8 MSG_BTN_DOWN  = 9\n"
    "int8 MSG_BTN_HOME  = 10\n"
    "\n"
    "#-----------------------------\n"
    "# Header\n"
    "#----------------------\n"
    "\n"
    "Header header\n"
    "\n"
    "#----------------------\n"
    "# Gyro reading\n"
    "#-----------------------------\n"
    "# In radians/sec. If reading is invalid,\n"
    "# for instance b/c no gyro is attached to the Wii, then\n"
    "# set first element of covariance to -1 (same as imu_data.msg):\n"
    "# Covariance matrix (roll, pitch, yaw) in radians^2/sec^2.\n"
    "\n"
    "geometry_msgs/Vector3 angular_velocity_zeroed\n"
    "geometry_msgs/Vector3 angular_velocity_raw\n"
    "float64[9] angular_velocity_covariance\n"
    "\n"
    "#----------------------\n"
    "# Accelerometer reading\n"
    "#-----------------------------\n"
    "# Acceleration in m/sec^2. Covariance matrix\n"
    "# (x,y,z) in m^2/sec^4.  (all same as imu_data.msg)\n"
    "\n"
    "geometry_msgs/Vector3 linear_acceleration_zeroed\n"
    "geometry_msgs/Vector3 linear_acceleration_raw\n"
    "float64[9] linear_acceleration_covariance\n"
    "\n"
    "#----------------------\n"
    "# Wiimote buttons\n"
    "#-----------------------------\n"
    "# Mappings from Wiimote button name\n"
    "# to array position are defined above.\n"
    "#\n"
    "bool[11] buttons\n"
    "\n"
    "#----------------------\n"
    "# Wiimote LED states:\n"
    "#-----------------------------\n"
    "\n"
    "bool[4] LEDs\n"
    "\n"
    "#----------------------\n"
    "# Wiimote Rumble\n"
    "#-----------------------------\n"
    "# State (True or False)\n"
    "\n"
    "bool rumble\n"
    "\n"
    "#----------------------\n"
    "# IR Light sensor (Camera)\n"
    "#-----------------------------\n"
    "# The Wiimote handles up to four light sources, \n"
    "# and the wiimote_node.py software is written to \n"
    "# that limit as well. For future expansion\n"
    "# we make the following array extensible, rather\n"
    "# than locking its length down to four:\n"
    "\n"
    "wiimote/IrSourceInfo[] ir_tracking\n"
    "\n"
    "#----------------------\n"
    "# Wiimote battery\n"
    "#-----------------------------\n"
    "# A battery reading consists of two numbers: \n"
    "# the battery percentage, and the raw reading.\n"
    "# Maximum battery is 208 units (unknown how this\n"
    "# relates to electrical properties): \n"
    "\n"
    "float32 raw_battery\n"
    "float32 percent_battery\n"
    "\n"
    "#----------------------\n"
    "# Time of most recent zeroing:\n"
    "#-----------------------------\n"
    "\n"
    "roslib/Time zeroing_time\n"
    "\n"
    "#----------------------\n"
    "# Error vector\n"
    "#-----------------------------\n"
    "# For error condition definitions see wiimoteConstants.py\n"
    "# Value of zero means all is well. (Currently NOT used).\n"
    "\n"
    "uint64 errors\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "================================================================================\n"
    "MSG: wiimote/IrSourceInfo\n"
    "# Sensor data pertaining to the Wiimote infrared camera.\n"
    "# This message contains data for one of the four infrared \n"
    "# light sources that the camera detects.\n"
    "#\n"
    "# Each light is specified with a 2D position and \n"
    "# a 'source magnitude' (ir_size). If the x dimension\n"
    "# is set to INVALID_FLOAT, then no light was detected for \n"
    "# the respective light. The Wiimote handles up to\n"
    "# four light sources, and the wiimote_node.py software\n"
    "# is written to that limit as well.\n"
    "#\n"
    "# I am unsure what the 'ir_size' values represent. \n"
    "# They are described as 'source magnitude' in some places. I\n"
    "# *assume* this is signal amplitude, but it's unclear. \n"
    "# Note that current lowest level cwiid driver does not \n"
    "# seem to pass the ir_size value to the cwiid Wiimote.c. \n"
    "# For now this size will therefore be set INVALID\n"
    "\n"
    "float64 x \n"
    "float64 y \n"
    "int64 ir_size\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Time\n"
    "# DEPRECATED. Please see roslib/Clock instead\n"
    "Header header\n"
    "time rostime\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_angular_velocity_covariance_size() const { return 9; }
  inline uint32_t get_linear_acceleration_covariance_size() const { return 9; }
  inline uint32_t get_buttons_size() const { return 11; }
  inline uint32_t get_LEDs_size() const { return 4; }
  void set_ir_tracking_size(uint32_t __ros_new_size)
  {
    this->ir_tracking.resize(__ros_new_size);
  }
  inline uint32_t get_ir_tracking_size() const { return ir_tracking.size(); }
  inline void get_ir_tracking_vec (std::vector<wiimote::IrSourceInfo> &__ros_vec) const
  {
    __ros_vec = this->ir_tracking;
  }
  inline void set_ir_tracking_vec(const std::vector<wiimote::IrSourceInfo> &__ros_vec)
  {
    this->ir_tracking = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 0; // INVALID
    __l += 0; // INVALID_FLOAT
    __l += 0; // MSG_BTN_1
    __l += 0; // MSG_BTN_2
    __l += 0; // MSG_BTN_A
    __l += 0; // MSG_BTN_B
    __l += 0; // MSG_BTN_PLUS
    __l += 0; // MSG_BTN_MINUS
    __l += 0; // MSG_BTN_LEFT
    __l += 0; // MSG_BTN_RIGHT
    __l += 0; // MSG_BTN_UP
    __l += 0; // MSG_BTN_DOWN
    __l += 0; // MSG_BTN_HOME
    __l += header.serializationLength(); // header
    __l += angular_velocity_zeroed.serializationLength(); // angular_velocity_zeroed
    __l += angular_velocity_raw.serializationLength(); // angular_velocity_raw
    __l += 9 * 8; // angular_velocity_covariance
    __l += linear_acceleration_zeroed.serializationLength(); // linear_acceleration_zeroed
    __l += linear_acceleration_raw.serializationLength(); // linear_acceleration_raw
    __l += 9 * 8; // linear_acceleration_covariance
    __l += 11 * 1; // buttons
    __l += 4 * 1; // LEDs
    __l += 1; // rumble
    __l += 4 + (ir_tracking.size() ? ir_tracking.size() * ir_tracking[0].serializationLength() : 0); // ir_tracking
    __l += 4; // raw_battery
    __l += 4; // percent_battery
    __l += zeroing_time.serializationLength(); // zeroing_time
    __l += 8; // errors
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    write_ptr = angular_velocity_zeroed.serialize(write_ptr, seq);
    write_ptr = angular_velocity_raw.serialize(write_ptr, seq);
    memcpy(write_ptr, &angular_velocity_covariance[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    write_ptr = linear_acceleration_zeroed.serialize(write_ptr, seq);
    write_ptr = linear_acceleration_raw.serialize(write_ptr, seq);
    memcpy(write_ptr, &linear_acceleration_covariance[0], sizeof(double) * 9);
    write_ptr += sizeof(double) * 9;
    memcpy(write_ptr, &buttons[0], sizeof(uint8_t) * 11);
    write_ptr += sizeof(uint8_t) * 11;
    memcpy(write_ptr, &LEDs[0], sizeof(uint8_t) * 4);
    write_ptr += sizeof(uint8_t) * 4;
    SROS_SERIALIZE_PRIMITIVE(write_ptr, rumble);
    uint32_t __ir_tracking_size = ir_tracking.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ir_tracking_size);
    for (size_t i = 0; i < __ir_tracking_size; i++)
      write_ptr = ir_tracking[i].serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, raw_battery);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, percent_battery);
    write_ptr = zeroing_time.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, errors);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    read_ptr = angular_velocity_zeroed.deserialize(read_ptr);
    read_ptr = angular_velocity_raw.deserialize(read_ptr);
    memcpy(&angular_velocity_covariance[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    read_ptr = linear_acceleration_zeroed.deserialize(read_ptr);
    read_ptr = linear_acceleration_raw.deserialize(read_ptr);
    memcpy(&linear_acceleration_covariance[0], read_ptr, sizeof(double) * 9);
    read_ptr += sizeof(double) * 9;
    memcpy(&buttons[0], read_ptr, sizeof(uint8_t) * 11);
    read_ptr += sizeof(uint8_t) * 11;
    memcpy(&LEDs[0], read_ptr, sizeof(uint8_t) * 4);
    read_ptr += sizeof(uint8_t) * 4;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, rumble);
    uint32_t __ir_tracking_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ir_tracking_size);
    set_ir_tracking_size(__ir_tracking_size);
    for (size_t i = 0; i < __ir_tracking_size; i++)
      read_ptr = ir_tracking[i].deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, raw_battery);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, percent_battery);
    read_ptr = zeroing_time.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, errors);
    return read_ptr;
  }
};

typedef boost::shared_ptr<State> StatePtr;
typedef boost::shared_ptr<State const> StateConstPtr;


}

#endif
