/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/joystick_drivers/wiimote/msg/TimedSwitch.msg.  Do not edit! */
#ifndef WIIMOTE_TIMEDSWITCH_H
#define WIIMOTE_TIMEDSWITCH_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace wiimote
{

//! \htmlinclude TimedSwitch.msg.html

class TimedSwitch : public ros::Message
{
public:
  typedef boost::shared_ptr<TimedSwitch> Ptr;
  typedef boost::shared_ptr<TimedSwitch const> ConstPtr;

  typedef int8_t _switch_mode_type;
  typedef int32_t _num_cycles_type;
  typedef std::vector<float> _pulse_pattern_type;

  const static int8_t ON = 1;
  const static int8_t OFF = 0;
  const static int8_t NO_CHANGE = -2;
  const static int8_t REPEAT = -1;
  const static int8_t FOREVER = -1;
  int8_t switch_mode;
  int32_t num_cycles;
  std::vector<float> pulse_pattern;

  TimedSwitch() : ros::Message(),
    switch_mode(0),
    num_cycles(0)
  {
  }
  TimedSwitch(const TimedSwitch &copy) : ros::Message(),
    switch_mode(copy.switch_mode),
    num_cycles(copy.num_cycles)
  {
    (void)copy;
    pulse_pattern = copy.pulse_pattern;
  }
  TimedSwitch &operator =(const TimedSwitch &copy)
  {
    if (this == &copy)
      return *this;
    pulse_pattern.clear();
    switch_mode = copy.switch_mode;
    num_cycles = copy.num_cycles;
    pulse_pattern = copy.pulse_pattern;
    return *this;
  }
  virtual ~TimedSwitch() 
  {
    pulse_pattern.clear();
  }
  inline static std::string __s_getDataType() { return std::string("wiimote/TimedSwitch"); }
  inline static std::string __s_getMD5Sum() { return std::string("e4c8d9327409cef6066fa6c368032c1e"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# TimedSwitch allows sender to:\n"
    "#    o turn a switch on,\n"
    "#    o turn a switch off, and\n"
    "#    o repeat an on/off pattern forever or for a\n"
    "#          given number of times.\n"
    "# Fields (refer to definitions of constants in the definition body):\n"
    "#     o switch_mode:\n"
    "#         ON: turn on  (num_cycles and pulse_pattern fields are ignored)\n"
    "#        OFF: turn off (num_cycles and pulse_pattern fields are ignored)\n"
    "#  NO_CHANGE: leave LED in its current state\n"
    "#     REPEAT: repeat an on/off pattern for as long\n"
    "#             as is indicated in the num_cycles field. The\n"
    "#             pattern is defined in the pulse_pattern field.\n"
    "#\n"
    "#     o num_cycles:\n"
    "#          n>=0: run the pattern that is defined in pulse_pattern\n"
    "#                n times.\n"
    "#          n==FOREVER: run the pattern that is defined in pulse_pattern\n"
    "#                       until a new TimedSwitch message is sent.              \n"
    "#\n"
    "#     o pulse_pattern:\n"
    "#          A series of time durations in fractions of a second. The\n"
    "#          first number is the duration for having the switch on.\n"
    "#          The second number is the duration for which the switch\n"
    "#          is off. The third is an 'on' period again, etc.\n"
    "#          A pattern is terminated with the end of the array.\n"
    "#           \n"
    "#          Example: [1,1] specifies an on-off sequence of 1 second.               \n"
    "\n"
    "int8 ON        =  1\n"
    "int8 OFF       =  0\n"
    "int8 NO_CHANGE = -2\n"
    "int8 REPEAT    = -1\n"
    "int8 FOREVER   = -1\n"
    "\n"
    "int8 switch_mode\n"
    "int32 num_cycles\n"
    "float32[] pulse_pattern\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_pulse_pattern_size(uint32_t __ros_new_size)
  {
    this->pulse_pattern.resize(__ros_new_size);
  }
  inline uint32_t get_pulse_pattern_size() const { return pulse_pattern.size(); }
  inline void get_pulse_pattern_vec (std::vector<float> &__ros_vec) const
  {
    __ros_vec = this->pulse_pattern;
  }
  inline void set_pulse_pattern_vec(const std::vector<float> &__ros_vec)
  {
    this->pulse_pattern = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 0; // ON
    __l += 0; // OFF
    __l += 0; // NO_CHANGE
    __l += 0; // REPEAT
    __l += 0; // FOREVER
    __l += 1; // switch_mode
    __l += 4; // num_cycles
    __l += 4 + (pulse_pattern.size() ? pulse_pattern.size() * 4 : 0); // pulse_pattern
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, switch_mode);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_cycles);
    uint32_t __pulse_pattern_size = pulse_pattern.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __pulse_pattern_size);
    memcpy(write_ptr, &pulse_pattern[0], sizeof(float) * __pulse_pattern_size);
    write_ptr += sizeof(float) * __pulse_pattern_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, switch_mode);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_cycles);
    uint32_t __pulse_pattern_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __pulse_pattern_size);
    set_pulse_pattern_size(__pulse_pattern_size);
    memcpy(&pulse_pattern[0], read_ptr, sizeof(float) * __pulse_pattern_size);
    read_ptr += sizeof(float) * __pulse_pattern_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<TimedSwitch> TimedSwitchPtr;
typedef boost::shared_ptr<TimedSwitch const> TimedSwitchConstPtr;


}

#endif
