# autogenerated by genmsg_py from RumbleControl.msg. Do not edit.
import roslib.message
import struct

import wiimote.msg

class RumbleControl(roslib.message.Message):
  _md5sum = "264ec2f3013a512070cd67c42486214e"
  _type = "wiimote/RumbleControl"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Message to control the Wiimote rumble (vibrator).
# We simply use a TimedSwitch. So rumble can
# be turned on (switch_mode == 1), off (switch_mode == 0),
# or pulsed with a timing pattern (switch_mode == -1).
# Number of times the cycle is repeated: num_cycles
# (-1: repeat till next RumbleControl message). pulse_pattern
# contains the time on/off pattern. (see also TimedSwitch.msg)

TimedSwitch rumble


================================================================================
MSG: wiimote/TimedSwitch
# TimedSwitch allows sender to:
#    o turn a switch on,
#    o turn a switch off, and
#    o repeat an on/off pattern forever or for a
#          given number of times.
# Fields (refer to definitions of constants in the definition body):
#     o switch_mode:
#         ON: turn on  (num_cycles and pulse_pattern fields are ignored)
#        OFF: turn off (num_cycles and pulse_pattern fields are ignored)
#  NO_CHANGE: leave LED in its current state
#     REPEAT: repeat an on/off pattern for as long
#             as is indicated in the num_cycles field. The
#             pattern is defined in the pulse_pattern field.
#
#     o num_cycles:
#          n>=0: run the pattern that is defined in pulse_pattern
#                n times.
#          n==FOREVER: run the pattern that is defined in pulse_pattern
#                       until a new TimedSwitch message is sent.              
#
#     o pulse_pattern:
#          A series of time durations in fractions of a second. The
#          first number is the duration for having the switch on.
#          The second number is the duration for which the switch
#          is off. The third is an 'on' period again, etc.
#          A pattern is terminated with the end of the array.
#           
#          Example: [1,1] specifies an on-off sequence of 1 second.               

int8 ON        =  1
int8 OFF       =  0
int8 NO_CHANGE = -2
int8 REPEAT    = -1
int8 FOREVER   = -1

int8 switch_mode
int32 num_cycles
float32[] pulse_pattern

"""
  __slots__ = ['rumble']
  _slot_types = ['wiimote/TimedSwitch']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   rumble
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(RumbleControl, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.rumble is None:
        self.rumble = wiimote.msg.TimedSwitch()
    else:
      self.rumble = wiimote.msg.TimedSwitch()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<bi', self.rumble.switch_mode, self.rumble.num_cycles))
      #serialize self.rumble.pulse_pattern
      length = len(self.rumble.pulse_pattern)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.rumble.pulse_pattern))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.rumble is None:
        self.rumble = wiimote.msg.TimedSwitch()
      end = 0
      start = end
      end += 5
      (self.rumble.switch_mode, self.rumble.num_cycles,) = struct.unpack('<bi',str[start:end])
      #deserialize self.rumble.pulse_pattern
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.rumble.pulse_pattern = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<bi', self.rumble.switch_mode, self.rumble.num_cycles))
      #serialize self.rumble.pulse_pattern
      length = len(self.rumble.pulse_pattern)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(self.rumble.pulse_pattern.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.rumble is None:
        self.rumble = wiimote.msg.TimedSwitch()
      end = 0
      start = end
      end += 5
      (self.rumble.switch_mode, self.rumble.num_cycles,) = struct.unpack('<bi',str[start:end])
      #deserialize self.rumble.pulse_pattern
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.rumble.pulse_pattern = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

