# autogenerated by genmsg_py from State.msg. Do not edit.
import roslib.message
import struct

import wiimote.msg
import roslib.rostime
import geometry_msgs.msg
import roslib.msg

class State(roslib.message.Message):
  _md5sum = "eb6e58dcb35bfb71c9eed6687cfd0377"
  _type = "wiimote/State"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#
#          Wiimote State message containing one complete Wiimote state

# Note: For ease of manipulation this message often uses
#       int8[] when a bit vector would work. One might
#       wish to use uint8[], but then Python takes
#       the respective structure as a string and disallows
#       item assignment.

int8    INVALID       = -1
float32 INVALID_FLOAT = -1.0

int8 MSG_BTN_1     = 0
int8 MSG_BTN_2     = 1
int8 MSG_BTN_A     = 2
int8 MSG_BTN_B     = 3
int8 MSG_BTN_PLUS  = 4
int8 MSG_BTN_MINUS = 5
int8 MSG_BTN_LEFT  = 6
int8 MSG_BTN_RIGHT = 7
int8 MSG_BTN_UP    = 8
int8 MSG_BTN_DOWN  = 9
int8 MSG_BTN_HOME  = 10

#-----------------------------
# Header
#----------------------

Header header

#----------------------
# Gyro reading
#-----------------------------
# In radians/sec. If reading is invalid,
# for instance b/c no gyro is attached to the Wii, then
# set first element of covariance to -1 (same as imu_data.msg):
# Covariance matrix (roll, pitch, yaw) in radians^2/sec^2.

geometry_msgs/Vector3 angular_velocity_zeroed
geometry_msgs/Vector3 angular_velocity_raw
float64[9] angular_velocity_covariance

#----------------------
# Accelerometer reading
#-----------------------------
# Acceleration in m/sec^2. Covariance matrix
# (x,y,z) in m^2/sec^4.  (all same as imu_data.msg)

geometry_msgs/Vector3 linear_acceleration_zeroed
geometry_msgs/Vector3 linear_acceleration_raw
float64[9] linear_acceleration_covariance

#----------------------
# Wiimote buttons
#-----------------------------
# Mappings from Wiimote button name
# to array position are defined above.
#
bool[11] buttons

#----------------------
# Wiimote LED states:
#-----------------------------

bool[4] LEDs

#----------------------
# Wiimote Rumble
#-----------------------------
# State (True or False)

bool rumble

#----------------------
# IR Light sensor (Camera)
#-----------------------------
# The Wiimote handles up to four light sources, 
# and the wiimote_node.py software is written to 
# that limit as well. For future expansion
# we make the following array extensible, rather
# than locking its length down to four:

wiimote/IrSourceInfo[] ir_tracking

#----------------------
# Wiimote battery
#-----------------------------
# A battery reading consists of two numbers: 
# the battery percentage, and the raw reading.
# Maximum battery is 208 units (unknown how this
# relates to electrical properties): 

float32 raw_battery
float32 percent_battery

#----------------------
# Time of most recent zeroing:
#-----------------------------

roslib/Time zeroing_time

#----------------------
# Error vector
#-----------------------------
# For error condition definitions see wiimoteConstants.py
# Value of zero means all is well. (Currently NOT used).

uint64 errors
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: wiimote/IrSourceInfo
# Sensor data pertaining to the Wiimote infrared camera.
# This message contains data for one of the four infrared 
# light sources that the camera detects.
#
# Each light is specified with a 2D position and 
# a 'source magnitude' (ir_size). If the x dimension
# is set to INVALID_FLOAT, then no light was detected for 
# the respective light. The Wiimote handles up to
# four light sources, and the wiimote_node.py software
# is written to that limit as well.
#
# I am unsure what the 'ir_size' values represent. 
# They are described as 'source magnitude' in some places. I
# *assume* this is signal amplitude, but it's unclear. 
# Note that current lowest level cwiid driver does not 
# seem to pass the ir_size value to the cwiid Wiimote.c. 
# For now this size will therefore be set INVALID

float64 x 
float64 y 
int64 ir_size

================================================================================
MSG: roslib/Time
# DEPRECATED. Please see roslib/Clock instead
Header header
time rostime

"""
  # Pseudo-constants
  INVALID = -1
  INVALID_FLOAT = -1.0
  MSG_BTN_1 = 0
  MSG_BTN_2 = 1
  MSG_BTN_A = 2
  MSG_BTN_B = 3
  MSG_BTN_PLUS = 4
  MSG_BTN_MINUS = 5
  MSG_BTN_LEFT = 6
  MSG_BTN_RIGHT = 7
  MSG_BTN_UP = 8
  MSG_BTN_DOWN = 9
  MSG_BTN_HOME = 10

  __slots__ = ['header','angular_velocity_zeroed','angular_velocity_raw','angular_velocity_covariance','linear_acceleration_zeroed','linear_acceleration_raw','linear_acceleration_covariance','buttons','LEDs','rumble','ir_tracking','raw_battery','percent_battery','zeroing_time','errors']
  _slot_types = ['Header','geometry_msgs/Vector3','geometry_msgs/Vector3','float64[9]','geometry_msgs/Vector3','geometry_msgs/Vector3','float64[9]','bool[11]','bool[4]','bool','wiimote/IrSourceInfo[]','float32','float32','roslib/Time','uint64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,angular_velocity_zeroed,angular_velocity_raw,angular_velocity_covariance,linear_acceleration_zeroed,linear_acceleration_raw,linear_acceleration_covariance,buttons,LEDs,rumble,ir_tracking,raw_battery,percent_battery,zeroing_time,errors
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(State, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.angular_velocity_zeroed is None:
        self.angular_velocity_zeroed = geometry_msgs.msg.Vector3()
      if self.angular_velocity_raw is None:
        self.angular_velocity_raw = geometry_msgs.msg.Vector3()
      if self.angular_velocity_covariance is None:
        self.angular_velocity_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.linear_acceleration_zeroed is None:
        self.linear_acceleration_zeroed = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_raw is None:
        self.linear_acceleration_raw = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_covariance is None:
        self.linear_acceleration_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.buttons is None:
        self.buttons = [False,False,False,False,False,False,False,False,False,False,False]
      if self.LEDs is None:
        self.LEDs = [False,False,False,False]
      if self.rumble is None:
        self.rumble = False
      if self.ir_tracking is None:
        self.ir_tracking = []
      if self.raw_battery is None:
        self.raw_battery = 0.
      if self.percent_battery is None:
        self.percent_battery = 0.
      if self.zeroing_time is None:
        self.zeroing_time = roslib.msg.Time()
      if self.errors is None:
        self.errors = 0
    else:
      self.header = roslib.msg._Header.Header()
      self.angular_velocity_zeroed = geometry_msgs.msg.Vector3()
      self.angular_velocity_raw = geometry_msgs.msg.Vector3()
      self.angular_velocity_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.linear_acceleration_zeroed = geometry_msgs.msg.Vector3()
      self.linear_acceleration_raw = geometry_msgs.msg.Vector3()
      self.linear_acceleration_covariance = [0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.buttons = [False,False,False,False,False,False,False,False,False,False,False]
      self.LEDs = [False,False,False,False]
      self.rumble = False
      self.ir_tracking = []
      self.raw_battery = 0.
      self.percent_battery = 0.
      self.zeroing_time = roslib.msg.Time()
      self.errors = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<6d', self.angular_velocity_zeroed.x, self.angular_velocity_zeroed.y, self.angular_velocity_zeroed.z, self.angular_velocity_raw.x, self.angular_velocity_raw.y, self.angular_velocity_raw.z))
      #serialize self.angular_velocity_covariance
      buff.write(struct.pack('<9d', *self.angular_velocity_covariance))
      buff.write(struct.pack('<6d', self.linear_acceleration_zeroed.x, self.linear_acceleration_zeroed.y, self.linear_acceleration_zeroed.z, self.linear_acceleration_raw.x, self.linear_acceleration_raw.y, self.linear_acceleration_raw.z))
      #serialize self.linear_acceleration_covariance
      buff.write(struct.pack('<9d', *self.linear_acceleration_covariance))
      #serialize self.buttons
      buff.write(struct.pack('<11B', *self.buttons))
      #serialize self.LEDs
      buff.write(struct.pack('<4B', *self.LEDs))
      buff.write(struct.pack('<B', self.rumble))
      #serialize self.ir_tracking
      length = len(self.ir_tracking)
      buff.write(struct.pack('<I', length))
      for val1 in self.ir_tracking:
        buff.write(struct.pack('<2dq', val1.x, val1.y, val1.ir_size))
      buff.write(struct.pack('<2f3I', self.raw_battery, self.percent_battery, self.zeroing_time.header.seq, self.zeroing_time.header.stamp.secs, self.zeroing_time.header.stamp.nsecs))
      length = len(self.zeroing_time.header.frame_id)
      #serialize self.zeroing_time.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.zeroing_time.header.frame_id))
      buff.write(struct.pack('<2IQ', self.zeroing_time.rostime.secs, self.zeroing_time.rostime.nsecs, self.errors))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.angular_velocity_zeroed is None:
        self.angular_velocity_zeroed = geometry_msgs.msg.Vector3()
      if self.angular_velocity_raw is None:
        self.angular_velocity_raw = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_zeroed is None:
        self.linear_acceleration_zeroed = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_raw is None:
        self.linear_acceleration_raw = geometry_msgs.msg.Vector3()
      if self.zeroing_time is None:
        self.zeroing_time = roslib.msg.Time()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 48
      (self.angular_velocity_zeroed.x, self.angular_velocity_zeroed.y, self.angular_velocity_zeroed.z, self.angular_velocity_raw.x, self.angular_velocity_raw.y, self.angular_velocity_raw.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.angular_velocity_covariance
      start = end
      end += 72
      self.angular_velocity_covariance = struct.unpack('<9d',str[start:end])
      start = end
      end += 48
      (self.linear_acceleration_zeroed.x, self.linear_acceleration_zeroed.y, self.linear_acceleration_zeroed.z, self.linear_acceleration_raw.x, self.linear_acceleration_raw.y, self.linear_acceleration_raw.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.linear_acceleration_covariance
      start = end
      end += 72
      self.linear_acceleration_covariance = struct.unpack('<9d',str[start:end])
      #deserialize self.buttons
      start = end
      end += 11
      self.buttons = struct.unpack('<11B',str[start:end])
      self.buttons = map(bool, self.buttons)
      #deserialize self.LEDs
      start = end
      end += 4
      self.LEDs = struct.unpack('<4B',str[start:end])
      self.LEDs = map(bool, self.LEDs)
      start = end
      end += 1
      (self.rumble,) = struct.unpack('<B',str[start:end])
      self.rumble = bool(self.rumble)
      #deserialize self.ir_tracking
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ir_tracking = []
      for i in xrange(0, length):
        val1 = wiimote.msg.IrSourceInfo()
        start = end
        end += 24
        (val1.x, val1.y, val1.ir_size,) = struct.unpack('<2dq',str[start:end])
        self.ir_tracking.append(val1)
      start = end
      end += 20
      (self.raw_battery, self.percent_battery, self.zeroing_time.header.seq, self.zeroing_time.header.stamp.secs, self.zeroing_time.header.stamp.nsecs,) = struct.unpack('<2f3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.zeroing_time.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.zeroing_time.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.zeroing_time.rostime.secs, self.zeroing_time.rostime.nsecs, self.errors,) = struct.unpack('<2IQ',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<6d', self.angular_velocity_zeroed.x, self.angular_velocity_zeroed.y, self.angular_velocity_zeroed.z, self.angular_velocity_raw.x, self.angular_velocity_raw.y, self.angular_velocity_raw.z))
      #serialize self.angular_velocity_covariance
      buff.write(self.angular_velocity_covariance.tostring())
      buff.write(struct.pack('<6d', self.linear_acceleration_zeroed.x, self.linear_acceleration_zeroed.y, self.linear_acceleration_zeroed.z, self.linear_acceleration_raw.x, self.linear_acceleration_raw.y, self.linear_acceleration_raw.z))
      #serialize self.linear_acceleration_covariance
      buff.write(self.linear_acceleration_covariance.tostring())
      #serialize self.buttons
      buff.write(self.buttons.tostring())
      #serialize self.LEDs
      buff.write(self.LEDs.tostring())
      buff.write(struct.pack('<B', self.rumble))
      #serialize self.ir_tracking
      length = len(self.ir_tracking)
      buff.write(struct.pack('<I', length))
      for val1 in self.ir_tracking:
        buff.write(struct.pack('<2dq', val1.x, val1.y, val1.ir_size))
      buff.write(struct.pack('<2f3I', self.raw_battery, self.percent_battery, self.zeroing_time.header.seq, self.zeroing_time.header.stamp.secs, self.zeroing_time.header.stamp.nsecs))
      length = len(self.zeroing_time.header.frame_id)
      #serialize self.zeroing_time.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.zeroing_time.header.frame_id))
      buff.write(struct.pack('<2IQ', self.zeroing_time.rostime.secs, self.zeroing_time.rostime.nsecs, self.errors))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.angular_velocity_zeroed is None:
        self.angular_velocity_zeroed = geometry_msgs.msg.Vector3()
      if self.angular_velocity_raw is None:
        self.angular_velocity_raw = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_zeroed is None:
        self.linear_acceleration_zeroed = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_raw is None:
        self.linear_acceleration_raw = geometry_msgs.msg.Vector3()
      if self.zeroing_time is None:
        self.zeroing_time = roslib.msg.Time()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 48
      (self.angular_velocity_zeroed.x, self.angular_velocity_zeroed.y, self.angular_velocity_zeroed.z, self.angular_velocity_raw.x, self.angular_velocity_raw.y, self.angular_velocity_raw.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.angular_velocity_covariance
      start = end
      end += 72
      self.angular_velocity_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 48
      (self.linear_acceleration_zeroed.x, self.linear_acceleration_zeroed.y, self.linear_acceleration_zeroed.z, self.linear_acceleration_raw.x, self.linear_acceleration_raw.y, self.linear_acceleration_raw.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.linear_acceleration_covariance
      start = end
      end += 72
      self.linear_acceleration_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.buttons
      start = end
      end += 11
      self.buttons = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=11)
      self.buttons = map(bool, self.buttons)
      #deserialize self.LEDs
      start = end
      end += 4
      self.LEDs = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=4)
      self.LEDs = map(bool, self.LEDs)
      start = end
      end += 1
      (self.rumble,) = struct.unpack('<B',str[start:end])
      self.rumble = bool(self.rumble)
      #deserialize self.ir_tracking
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ir_tracking = []
      for i in xrange(0, length):
        val1 = wiimote.msg.IrSourceInfo()
        start = end
        end += 24
        (val1.x, val1.y, val1.ir_size,) = struct.unpack('<2dq',str[start:end])
        self.ir_tracking.append(val1)
      start = end
      end += 20
      (self.raw_battery, self.percent_battery, self.zeroing_time.header.seq, self.zeroing_time.header.stamp.secs, self.zeroing_time.header.stamp.nsecs,) = struct.unpack('<2f3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.zeroing_time.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.zeroing_time.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.zeroing_time.rostime.secs, self.zeroing_time.rostime.nsecs, self.errors,) = struct.unpack('<2IQ',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

